module Storing
	class AbstractAdaptor
		def query query_object
			raise NotImplementedError
		end

		def select table_name, conditions={}
			raise NotImplementedError
		end

		def insert table_name, params={}
			raise NotImplementedError
		end

		def update table_name, conditions={}, params={}
			raise NotImplementedError
		end

		def delete table_name, conditions={}
			raise NotImplementedError
		end

		def transaction &block
			raise NotImplementedError
		end
	end
end