require 'storing/abstract/abstract_deleter'

module Storing
	class Deleter < AbstractDeleter

		def self.delete entity, mapper, store
			new(entity, mapper, store).delete
		end

		attr_reader :entity, :mapper, :store

		def initialize entity, mapper, store
			@entity = entity
			@mapper = mapper
			@store = store
		end

		def delete
			store.delete(data)
		end

		private

		def data
			mapper.dump_to_table(entity, table_name)
		end

		def table_name
			store.table_name
		end
	end
end