require 'storing/abstract/abstract_inserter'

module Storing
	class Inserter < AbstractInserter

		def self.insert entity, mapper, store
			new(entity, mapper, store).insert
		end

		attr_reader :entity, :mapper, :store

		def initialize entity, mapper, store
			@entity = entity
			@mapper = mapper
			@store = store
		end

		def insert
			store.insert(data)
		end

		private

		def data
			mapper.dump_to_table(entity, table_name)
		end

		def table_name
			store.table_name
		end
	end
end


