require 'storing/abstract/abstract_query'

module Storing
	module Postgres
		class AbstractQuery < ::Storing::AbstractQuery
			attr_reader :query_object

			def initialize query_object=nil
				@query_object = query_object
			end

			def query database
				query_chain(database).select_sql
			end

			def query_chain database
				ds = call_query_chain(database)
				dataset(ds)
			end

			def dataset ds
				raise NotImplementedError
			end

			private

			def call_query_chain database
				query_object ? query_object.query_chain(database) : database
			end
		end
	end
end