require 'storing/abstract/abstract_updater'

module Storing
	class Updater < AbstractUpdater

		def self.update entity, mapper, store
			new(entity, mapper, store).update
		end

		attr_reader :entity, :mapper, :store

		def initialize entity, mapper, store
			@entity = entity
			@mapper = mapper
			@store = store
		end

		def update
			store.update(data)
		end

		private

		def data
			mapper.dump_to_table(entity, table_name)
		end

		def table_name
			store.table_name
		end
	end
end